#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include "xdnd.h"

int main()
{
  Display *dpy = XOpenDisplay(NULL);
  int screen = DefaultScreen(dpy);
  Window root = RootWindow(dpy, screen);
  int depth = DefaultDepth(dpy, screen);
  Window win = XCreateSimpleWindow(dpy, root, 0, 0, 100, 100, 3, 0, 0);
  int chk;
  XEvent ev;
  DndClass dnd;
  Atom *atm;	 
  Atom ah = XInternAtom(dpy, "bah", False);
  Atom uhh = XA_STRING;
	 
  XMapWindow(dpy, win);
  
  atm = (Atom *)malloc(sizeof(Atom) * 3);
  atm[0] = XInternAtom(dpy, "text/uri-list", False);
  atm[1] = XA_STRING;
  atm[2] = 0;
  xdnd_init(&dnd, dpy); 
  xdnd_set_dnd_aware(&dnd, win, atm);

  while (1)
  {
    XNextEvent(dpy, &ev);
    Window src;
    int want_selection = 0;
    
    switch (ev.type)
    {
      case SelectionRequest:
	      printf("selectionRequest:\n");
	      break;
      case SelectionNotify:

//	if (want_selection)
	{
	  Atom type;
	  int result, format;
	  unsigned long len, bytes, dummy;
	  unsigned char *data;
	  XSelectionEvent selEv = ev.xselection;
	  Display *dpy = selEv.display;
	  if (selEv.target != None)
	  printf("%s\n", XGetAtomName(dpy, selEv.target));
	  if (selEv.property != None)
	    printf("%s\n", XGetAtomName(dpy, selEv.property)); 
/*	  if (selEv.selection != None)
            printf("%s\n", XGetAtomName(dpy, selEv.selection)); */
	  result = XGetWindowProperty(selEv.display, selEv.requestor, ah, 0, 1024, 0, uhh, &type, &format, &len, &bytes, &data);
	  printf("got %i %i '%s' %i\n", len , bytes, data, result == Success);
	  while (bytes > 0)
	  {
 	    
	    result = XGetWindowProperty(selEv.display, selEv.requestor, ah, 0, bytes, 0, uhh, &type, &format, &len, &bytes, &data);
	    if (result == Success)
	      {
		printf("'%s'\n", data);
	      }
	    else 
	      {
	        printf("not sucssesful\n");
	      }
	    XFree(data);
	  }
	  xdnd_send_finished(&dnd, src, win, 0);
	}
      break;
      case ClientMessage:
      {
	Atom msg = ev.xclient.message_type;

	if (msg == dnd.XdndEnter)
          {
	    //uhh = ev.xclient.data.l[2];
	  }
	  printf("XdndEnter\n");
	if (msg == dnd.XdndPosition) 
	  {
            src = XDND_POSITION_SOURCE_WIN(&ev);
            Atom action = XDND_POSITION_ACTION(&ev);
	    printf("0x%lx\n", src);
	    xdnd_send_status(&dnd, src, win, 1, 0, 0, 0, 100, 100, action);
	    printf("XdndPosition\n");
	  }
	if (msg == dnd.XdndDrop)
	  {
	    printf("XdndDrop\n");
//	    want_selection = 1;
	    dnd.Xdnd_NON_PROTOCOL_ATOM=ah;
	    xdnd_convert_selection(&dnd, XDND_DROP_SOURCE_WIN(&ev), win,  uhh);
	    XFlush(dpy);
	  }

      }
      break;
    }
  }
  XCloseDisplay(dpy);
  return 0;
}
